// //////////////////////////////////////////////////////////////////////
// Import section
// //////////////////////////////////////////////////////////////////////
// STL
#include <sstream>
// SEvMgr
#include <sevmgr/bom/EventQueueKey.hpp>

namespace SEVMGR {

  // ////////////////////////////////////////////////////////////////////
  EventQueueKey::EventQueueKey (const EventQueueID_T& iEventQueueID)
    : _eventQueueID (iEventQueueID) {
  }
  // ////////////////////////////////////////////////////////////////////
  EventQueueKey::EventQueueKey (const EventQueueKey& iKey)
    : _eventQueueID (iKey._eventQueueID) {
  }

  // ////////////////////////////////////////////////////////////////////
  EventQueueKey::~EventQueueKey () {
  }

  // ////////////////////////////////////////////////////////////////////
  void EventQueueKey::toStream (std::ostream& ioOut) const {
    ioOut << "EventQueueKey: " << toString() << std::endl;
  }

  // ////////////////////////////////////////////////////////////////////
  void EventQueueKey::fromStream (std::istream& ioIn) {
  }

  // ////////////////////////////////////////////////////////////////////
  const std::string EventQueueKey::toString() const {
    std::ostringstream oStr;
    oStr << _eventQueueID;
    return oStr.str();
  }

}
